#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	chrony
Version		:	4.3
Release		:	14.4.0.0%{?dist}
Summary		:	The NTP daemon and utilities

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2
URL		:	https://chrony.tuxfamily.org/

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	bison
BuildRequires	:	gcc
BuildRequires	:	gcc-c++
BuildRequires	:	libedit-devel
BuildRequires	:	openssl-devel
BuildRequires	:	make
BuildRequires	:	nettle

Requires	:	lfs-bootscripts
Requires	:	chkconfig

Obsoletes	:	ntpsec	<= 1.2.1

#-----------------------------------------------------------------------------
%description
chrony is a versatile implementation of the Network Time Protocol (NTP).
It can synchronise the system clock with NTP servers, reference clocks
(e.g. GPS receiver), and manual input using wristwatch and keyboard. It
can also operate as an NTPv4 (RFC 5905) server and peer to provide a time
service to other computers in the network.
 

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc FAQ NEWS README
%license COPYING
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config (noreplace) %{_sysconfdir}/logrotate.d/%{name}
%dir %attr(755,%{name},%{name}) %{_var}/lib/%{name}/
%dir %attr(755,%{name},%{name}) %{_var}/log/%{name}/
%{_bindir}/%{name}c
%{_sbindir}/%{name}d
%{_mandir}/man1/%{name}c.1.gz
%{_mandir}/man5/%{name}.conf.5.gz
%{_mandir}/man8/%{name}d.8.gz

#-----------------------------------------------------------------------------
%pre
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{name}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}
    /usr/sbin/useradd 				\
	-r					\
	-c "Network Time Protocol"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /sbin/nologin			\
	-d %{_var}/lib/%{name}			\
	%{name}
    fi
  fi

#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}
  /usr/sbin/userdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add %{name}
  fi
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

tar xf %{SOURCE1}

export	ERA=$(date -d '1970-01-01 00:00:00+00:00' +'%s')
./configure						\
        --prefix=%{_prefix}				\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--chronyrundir=/run/%{name}			\
	--enable-scfilter				\
	--with-ntp-era=$ERA				\
	--with-hwclockfile=%{_sysconfdir}/adjtime 	\
	--with-pidfile=/run/%{name}/%{name}d.pid	\
	--with-user=%{name}				\
	--with-sendmail=%{_sbindir}/sendmail		\
	--with-rtcdevice=/dev/rtc			\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} 						\
	%{_smp_mflags}					\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/
%{__cp} -a 						\
	%{name}-ok_addon/%{name}-init			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/%{name}
	
%{__cp} -a 						\
	examples/%{name}.conf.example3			\
	%{buildroot}%{_sysconfdir}/%{name}.conf

(
echo "#======================================================================"
echo "#Configuration Preset by osukiss <"`date`">"
%{__cat}						\
	%{name}-ok_addon/%{name}.conf			\
)	>>  %{buildroot}%{_sysconfdir}/%{name}.conf

%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} -a 						\
	%{name}-ok_addon/logrotate			\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{name}

#chrony working directory
%{__mkdir_p}						\
	%{buildroot}%{_var}/lib/%{name}			\
	%{buildroot}%{_var}/log/%{name}			\

#-----------------------------------------------------------------------------
%changelog
